package matsubara.graphics;

import java.awt.Color;
import java.awt.Graphics;

/**
 * <p>^Cg:  Progress Line</p>
 * <p>:    i\郉CE]\邱Ƃo܂B</p>
 * <p>쌠: Copyright (c) 2002 matsubara masakazu </p>
 * @author m.matsubara
 * @version 1.0
 */

public class ProgressLine extends LineBase {
  int m_nPosition = 0;
  boolean m_bReverse = false;
  int m_nMarkSize = 0;

  /**
   * i\̏
   * @param nStartX JnXW
   * @param nStartY JnYW
   * @param nEndX IXW
   * @param nEndY IYW
   * @param color F
   */
  public ProgressLine(int nStartX, int nStartY, int nEndX, int nEndY, Color color) {
    super(nStartX, nStartY, nEndX, nEndY, color);
  }
  /**
   * i\̏
   * @param nStartX JnXW
   * @param nStartY JnYW
   * @param nEndX IXW
   * @param nEndY IYW
   * @param color F
   * @param nMarkSize iL̑傫
   */
  public ProgressLine(int nStartX, int nStartY, int nEndX, int nEndY, Color color, int nMarkSize) {
    super(nStartX, nStartY, nEndX, nEndY, color);
    setMarkSize(nMarkSize);
  }

  /**
   * i\`悷
   * @param g `Ɏg Graphics IuWFNg
   */
  public void draw(Graphics g) {
    /**@todo:  matsubara.arrow.ArrowBase abstract \bh*/
    drawArrow(g);
    int nX, nY;
    if (isReverse() == false) {
      nX = getStartX() + (getEndX() - getStartX()) * getPosition() / 100;
      nY = getStartY() + (getEndY() - getStartY()) * getPosition() / 100;
    }
    else {
      nX = getStartX() + (getEndX() - getStartX()) * (100 - getPosition()) / 100;
      nY = getStartY() + (getEndY() - getStartY()) * (100 - getPosition()) / 100;
    }
    g.setColor(Color.white);
    g.fillArc(nX - m_nMarkSize / 2, nY - m_nMarkSize / 2, m_nMarkSize, m_nMarkSize, 0, 360);
  }

  /**
   * ݂̐iʒuݒ肷
   * @param nPosition ݂̐iʒu(0`100)
   */
  public void setPosition(int nPosition) {
    m_nPosition = nPosition % 100;
  }
  /**
   * ݂̐iʒu擾
   * @return ݂̐iʒu(n/100)
   */
  int  getPosition() {
    return m_nPosition;
  }
  /**
   * ii߂
   * @param n i߂鐔
   */
  public void movePosition(int n) {
    m_nPosition = (m_nPosition + n) % 100;
    if (m_nPosition < 0)
      m_nPosition += 100;
  }
  /**
   * i\t]
   * JnWƏIWւ
   * @param bReverse ւƂ true
   */
  public void setReverse(boolean bReverse) {
    m_bReverse = bReverse;
  }
  /**
   * i\t]Ă邩擾
   * @return i\t]ĂƂ true
   */
  public boolean isReverse() {
    return m_bReverse;
  }
  /**
   * i}[NTCY擾
   * @return i}[NTCY
   */
  public int getMarkSize() {
    return m_nMarkSize;
  }
  /**
   * i}[NTCYݒ肷
   * @param nMarkSize Vi}[NTCY
   */
  public void setMarkSize(int nMarkSize) {
    m_nMarkSize = nMarkSize;
  }
}